{{******************************************************************************************
   The QuadCopter-System - Project
   by
   Rytta Communications Inc.                        
   (c) Version 0.10. June 2012 
   NEWEST VERSION: erstellt in propTool 11.06.20122
                                                                            
   TESTPROGRAM FOR ONLINE-TEST LASER-RANGE-FINDER (LRF_Basic.spin)
   ***************************************************************************************
   
   lrfBaseTest_1.spin  (base LRF_Basic.sping orig ParallaxDemo)
   -------------------
   begin       : Monday 11. June 2012  15.00:00 GMT 2012
   copyright   : (c) 2003, 2006, 2009, 2010,2011,2012  by s.morf
   email       : stevenmorf@bluewin.ch
   SpinProgramm:

   For         : onlineTest on PPDB : LASER-RANGE-FINDER-Device
    
   ****************************************************************************************
NOTES:
11.06. - interductions SoftWare-Development with PPB:
            - Laser-Range-Finder OnlineTests with PST
          - devs(1)
            - da jetzt schon 15.00 stop now
            - software -> orig. LRF_Basic.spin
            - verkabelung
              - connection to ppdb
              Laser Range Finder Connector (4 pin male header) im test mit 5-adrigen kabel
              ────────────────────────────────────────────────

              SIN     ────── P6        -  yellow    
              SOUT    ────── P7        -  white
              VCC     ────── +5V (VDD) -  black
              GND     ──────┐           -  red
                             
                           GND (VSS)

12.06. - Devs + Research (1)
         - 1.Versuche + OnlineTests
           - 1) verkabelt ss. oben
           - 2) only compile ok
           - 3) 1.run -> laser gegen monitor
                - bevor run backside LED: orange wait for <U>
                - RUN soweit ok
                  - pst.output Distance = 42.1cm 16.5"
                    backside: red LED
                - running mode:
                  input <R> neue Messung - gegen Decke: Distance = 126.1 cm 49.6"
                        <R> "              Monitor    : Distance =  53.1 cm 20.9"
                  - auf den angepeilten Gegenstand == RED LASER LIGHT BLINKING
                    - backside = after RED Led
           - 4) 1. Online-Base-Test verry OK
30.06. - Einbau into MainFrame with Ping
         - nach einig hickhack Distance = 44.3 cm ok
         - restart ok then NOK
           - noch sehr unzuverlaessig.....
         - 2. versuch verry nok Orange Led on no reactions ???
           - ist jetzt eingebaut, und funzzt nicht........
           - jetzt 13.50 STOP.... AND WAIT
       - Neuer Versuch 14.30    
         - C3 Run OK
           - Neue Erkenntnis
             - On LaserSide (left Laser Right a verry little Point (Sensor)
               - if no sight then 0.0cm if on sight 41.5cm
               - now change the abdeckung OK
       - fertigstellen des gehaeuses mit bohrung 2.sensor Unterseite frontside ok
       - abdeckung unterhalb von propdeck mit klebestreifen                    ok
       - ausschnitt fuer backside led ok hinterseite
01.07. - weitere OnlineTests im verbauten Zustand:               
         - verry ok
           - deviceLed -1 orange
                       -2 green
                       -3 red
           - dist = max. 196cm
           - restart app
             - led red
             - dist = 33.5cm
       - OK
07.07. - onlinetests NOK
         - POWER : BLACK = +5V RED = GND (WAR FALSCH)
           - 2.VERSUCH = LED ORANGE

14.07. - 1.versuche ppb + lrf
         - pin = 1  SIN  - yellow - red
           pin = 2  SOUT - white  - black
           +5v =    black                                                  
           gnd =    red
           no resistors
           - with big 1kohm NOK
       - run NOK
       - ueberlegung:
         - da bei c3 p6,p7 == 0.33ohm and run ok
           - after lunch more test
 
 23.09.2016 Testing with PAB
            - build ok
            - run ok 
           
-------------------------------------------------------------------------------------------------
REFERENCES:
-----------

             Laser Range Finder Connector (4 pin male header) im test mit 5-adrigen kabel
              ────────────────────────────────────────────────

              SIN     ────── P6         
              SOUT    ────── P7
              VCC     ────── +5V (VDD)
              GND     ──────┐
                             
                           GND (VSS)
                           

            
                     
****************************************************************************************

┌───────────────────────────────────────────────┐
│ Laser Range Finder: Basic Demonstration       │
│                                               │
│ Author: Joe Grand [www.grandideastudio.com]   │
│ Contact: support@parallax.com                 │ 
│                                               │
│ See end of file for terms of use.             │                      
└───────────────────────────────────────────────┘
                          
Program Description:

This program demonstrates the Parallax Laser Range Finder (LRF) module.
The distance to the target object is displayed in the Parallax Serial Terminal.  


Laser Range Finder Connector (4 pin male header)
────────────────────────────────────────────────

SIN     ────── P6
SOUT    ────── P7
VCC     ────── +5V (VDD)
GND     ──────┐
               
              GND (VSS)


Revisions:

1.1 (July 2011): Initial release
 
****************************************************************************************
}}


CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  LRF_TX        = 0   '5             ' Serial output to LRF (connects to SIN)
  LRF_RX        = 1   '6             ' Serial input from LRF (connects to SOUT)
 
VAR
  long range                    ' Distance from LRF module to target object (in millimeters)
    
OBJ
  pst       : "ParallaxSerialTerminal"                   ' Debug Terminal
  serial    : "Extended_FDSerial"                          ' Extended Full Duplex Serial by Martin Hebel (http://obex.parallax.com/objects/31/)
  
PUB main
  pst.Start(115_200)            ' Set Parallax Serial Terminal to 115.2kbps             
  pst.Str(@InitHeader)          ' Print header; uses string in DAT section.

  ' Set-up serial port for communication with the LRF module
  serial.Start(LRF_RX, LRF_TX, %0000, 115_200)          ' Start serial port, normal mode, 115.2kbps
  
 {{
   When the LRF powers on, it launches an auto-baud routine to determine the
   host's baud rate. It will stay in this state until a "U" ($55) character
   is sent by the host.
 }}
  pst.Str(String("Waiting for LRF module..."))
  waitcnt(clkfreq << 1 + cnt)                           ' Delay for 2 seconds to let the LRF module start-up
  serial.Tx("U")                                        ' Send character
  repeat until serial.RxCheck == ":"                    ' When the LRF has initialized and is ready to go, it will send a single ':' character, so wait here until we receive it
  pst.Str(String("Ready!", pst#NL, pst#NL))             ' Ready to go!

  repeat
    {{
      When a single range (R) command is sent, the LRF returns the distance to the target
      object in ASCII in millimeters. For example:
5
      D = 0123
    }}

    serial.Tx("R")                                      ' Send command
    repeat until serial.RxCheck == "D"                  ' Wait for the header to be sent...
    repeat until serial.RxCheck == "="                  '
    repeat until serial.RxCheck == " "                  '              
    range := serial.RxDec                               ' ...then grab the value
    
    ' With the data in hand, let's display it...
    pst.Str(String("Distance = "))
    pst.Dec(range / 10)
    pst.Char(".")
    pst.Dec(range // 10)
    pst.Str(String(" cm, "))                            ' ... in centimeters
    pst.Chars(pst#NL, 1)   ' CR Newline                                                           ' 
{
    range := (range * 10) ** 169_093_200                ' convert mm to hundredths of an inch (169_093_200 = 1 / 25.4 * $FFFFFFFF)
    pst.Dec(range / 10)
    pst.Char(".")
    pst.Dec(range // 10)
    pst.Str(String(34, pst#CE, pst#NL, pst#MU))         ' ...and in inches
}
DAT
InitHeader    byte "Parallax Laser Range Finder", pst#NL 
              byte "Basic Range Demonstration", pst#NL, pst#NL, 0


{{
┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
}}     
